RDMA_CREATE_SRQ(3)

NAME
rdma_create_srq - Allocate a shared receive queue.

SYNOPSIS
#include <rdma/rdma_verbs.h>

int rdma_create_srq (struct rdma_cm_id *id, struct ibv_pd *pd, struct ibv_srq_init_attr *attr);

ARGUMENTS

id  RDMA identifier.

pd  Optional protection domain for the SRQ.

attr
    Initial SRQ attributes.

DESCRIPTION
Allocate a SRQ associated with the specified rdma_cm_id.

RETURN VALUE
Returns 0 on success, or -1 on error. If an error occurs, errno will be set to indicate the failure reason.

NOTES
The rdma_cm_id must be bound to a local RDMA device before calling this function, and the protection domain, if provided, must be for that same device. After being allocated, the SRQ will be ready to handle posting of receives.

If a protection domain is not given - pd parameter is NULL - then the rdma_cm_id will be created using a default protection domain. One default protection domain is allocated per RDMA device.

The initial SRQ attributes are specified by the attr parameter. The ext.xrc.cq fields in the ibv_srq_init_attr is optional. If a completion queue is not specified for an XRC SRQ, then a CQ will be allocated by the rdma_cm for the SRQ, along with corresponding completion channels. Completion channels and CQ data created by the rdma_cm are exposed to the user through the rdma_cm_id structure.

The actual capabilities and properties of the created SRQ will be returned to the user through the attr parameter. An rdma_cm_id may only be associated with a single SRQ.

SEE ALSO
rdma_bind_addr(3), rdma_resolve_addr(3), rdma_create_ep(3), rdma_destroy_srq(3), ibv_create_srq(3), ibv_create_xsrq(3)